function [MVDR_out_post ] = calc_MI_opt_post(input,fs,setup)



s=input.s;
mvdr_out=input.mvdr_out;
u=input.mvdr_noise; %beamformed noise (\sigma_m)
n=input.n;

s       = s(:);% original speech
n       = n(:);%near-end noise
u       = u(:); %beamformed noise (\sigma_m)
%%
%%%%%%%%%%%% SII parameters. These are used to calcualte the \rho_0^2 (speech production uncertainty. speech production uncertainty parameters are thus based on the SII BI weightings)
sii_bl  = [100 200 300 400 510 630 770 920 1080 1270 1480 1720 2000 2320\...
    2700 3150 3700 4400 5300 6400 7700; 200 300 400 510 630 770 920 1080\...
    1270 1480 1720 2000 2320 2700 3150 3700 4400 5300 6400 7700 9500];
sii_cf  = exp(mean(log(sii_bl)));
sii_bi  = [0.0103 0.0261 0.0419 0.0577 0.0577 0.0577 0.0577 0.0577 0.0577 \...
    0.0577 0.0577 0.0577 0.0577 0.0577 0.0577 0.0577 0.0577 0.0460 0.0343 0.0226 0.0110].'; % band importance

NN      = round(fs*32/1000); % frame size
[H cf]  = gt_getfb(150, min(fs/2, 8500), fs, NN*2, 64);
w       = interp1(sii_cf, sii_bi, cf, 'linear', 'extrap');% generate band importance weights for 64 channels;
w       = w./sum(w);
w       = max(w, 0);%%%SII band importance weights
%%%%%%%%Here we use the waveforms to calcualte  spectra. These are later on only used to calculate average PSDs. We thus
%%%%%%%%do not use the actual spectra, only the average PSDs. Each of these
%%%%%%%%can easily be estimated in practice (the speech PSD  is thus only the average PSD of speech)
S    	= gt_analysis(s, H, NN);% compute speech energy in 1/3 octave bands
U    	= gt_analysis(u, H, NN);% comptue noise energy in 1/3 octave bands
MVDR_out  	= gt_analysis(mvdr_out, H, NN);% compute mvdr energy in 1/3 octave bands (speech plus processed noise)
N       = gt_analysis(n, H, NN); % compute noise energy at near-end in 1/3 octave bands
%%%%%%%%%%%%%%Calcualte the rho_0 (speech production uncertainty) based on
%%%%%%%%%%%%%%the SII BI functions.
setup.cf=cf;
setup.rho0=sqrt(1-2.^(w./(-0.5)));% compute rho0 such that it equals the BI functions.
setup.w=w;
%%
%%%%%calculate the proposed method

[ MVDR_out_post_oct_bands]=get_optimla_weights(MVDR_out,S,U,N,setup);
MVDR_out_post 	= gt_synthesis( MVDR_out_post_oct_bands, mvdr_out+randn(size(s))*std(mvdr_out)/(10e6), H, NN);% 

%%


end





