function [MVDR_out_post_with_near_end,noisy_unprocessed,mvdr_out_with_near_end]= generate_data_and_mvdr(s, n,u,un_corr , fs,d, NN)
%
%
%% initializing the parameters
[Nm,~,Nu]=size(d);
hop = NN/2;
N_frames=floor((length(s)-NN)/hop);

%%%%%%%%%%%%%%%%%%%Generating signals according to signal model
%%
S    	= analysis(s, NN,hop,N_frames);
for l=1:Nu-1 % number of noise sources
    U(:,:,l) 	= analysis(u(:,l), NN,hop,N_frames);
end
%applying the room transfer function (RTF) to the noise

for l=1:Nm
    UN_corr(:,:,l)   	= analysis(un_corr(:,l), NN,hop,N_frames);
    for nu=1:Nu-1;
        UD(:,:,l,nu) = repmat(d(l,:,nu+1).',[1,N_frames]).*U(:,:,nu);
        
    end
end
UD= sum(UD,4)+ UN_corr; %uncorrelated noise is gaussian noise


%applying the room transfer function (RTF) to clean speech
for l=1:Nm
    SD(:,:,l) = repmat(d(l,:,1).',[1,N_frames]).*S;
end

mics_speech=zeros(N_frames*hop+NN,Nm);
mics_noise=zeros(N_frames*hop+NN,Nm);
% generate wave-files
for l=1:Nm
    mics_speech(:,l)=  synthesis(SD(:,:,l), NN,hop,N_frames);
    mics_noise(:,l)=  synthesis(UD(:,:,l), NN,hop,N_frames);
    
end



X=zeros(size(SD));
SD=zeros(size(X));
UD =zeros(size(X));

% read to wavefiles and generate the signal model
for l=1:Nm
    SD(:,:,l)=  analysis( mics_speech(:,l), NN,hop,N_frames);
    UD(:,:,l)=  analysis( mics_noise(:,l), NN,hop,N_frames);
    X(:,:,l)=SD(:,:,l) + UD(:,:,l);  %signal plus noise at lth mic
end

%%%%%%%%%%%%calculating beamformer (standard MVDR based on far-end noise correlation matrices)
% calculating the correlation matrices
K=hop+1;
cvar_U=zeros(Nm,Nm,K);
for k=1:K   %iteration over frequency
    Uk  = squeeze(UD(k,:,:)).';
    for II=1:N_frames
        cvar_U(:,:,k)  = Uk(:,II)*Uk(:,II)'+cvar_U(:,:,k) ;
    end
end
cvar_U= cvar_U/N_frames;
clear Uk
%%%%%%%%%%%%%%%calculating beamformer coefficients
w=zeros(Nm,K);
for k=1:K
    DU=(cvar_U(:,:,k))\d(:,k,1);
    w(:,k)=(DU)./( d(:,k,1)'*DU ); %MVDR beamformer
  
end
%%for dc bin:
w(:,1)=0;


X_far_end=zeros(hop+1,N_frames);
xb=X_far_end;

% apply the beamformer per frame
for I=1:N_frames
    Xb(:,I,1)   =sum(w(:,:,1)'.*squeeze(X(:,I,:)),2); %after beamforming
    Xb(:,I,2)   =sum(w(:,:,1)'.*squeeze(UD(:,I,:)),2); %beamformed noise
    Xb(:,I,3)   =X(:,I,1);                           %noisy speach at microphone 1
end

%%
[mvdr_out]      =  synthesis(Xb(:,:,1)  , NN,hop,N_frames); %speech after beamforming
[mvdr_noise]    =  synthesis(Xb(:,:,2)   , NN,hop,N_frames); %beamformed noise (\sigma_m)
[noisy_mic]     =  synthesis(Xb(:,:,3)   , NN,hop,N_frames); %speech before beamforming at mic. 1



input.mvdr_out=mvdr_out(1:length(mvdr_noise)); 
input.mvdr_noise=mvdr_noise(1:length(mvdr_noise)); % processed far-end noise 
input.s=s(1:length(mvdr_noise));% original clean speech 
input.n=n(1:length(mvdr_noise));% near-end noise
noisy_unprocessed=noisy_mic+input.n; % unprocessed speech with (unprocessed) noise from far-end and near-end
mvdr_out_with_near_end=mvdr_out+input.n; % unprocessed speech with   near-end noise and beamformed noise from far-end 

%%
% finding the optimal post processor
[  MVDR_out_post] = calc_MI_opt_post(input,fs,[]);
%%%%Make sure the two methods have similar energy for fair comparison.
  MVDR_out_post=MVDR_out_post*(norm(mvdr_out)/norm(MVDR_out_post));
MVDR_out_post_with_near_end =MVDR_out_post+input.n; 
end