function [ MVDR_out_post]=get_optimla_weights(MVDR_out,fidata,udata,fnoisedata,setup)

% to shorten notation
rho0=setup.rho0;
 s=size(MVDR_out);
MVDR_out_post=zeros(s(1),s(2));


S=abs(fidata);
U=abs(udata);
N=abs(fnoisedata);
VAD     = 10*log10(mean(S.^2))>(max(10*log10(mean(S.^2)))-60); 
% simple voice activity detector, used to compute average speech and noise 
% power spectral in speech present frames.

% find parameters
freqno = size(fidata,1);
var_n = mean(N(:,VAD).^2,2); % over the rows
var_s = mean(S(:,VAD).^2,2);
var_u = mean(U(:,VAD).^2,2);
desiredpower = sum(var_s);

    

%


% find lambda
rho02=rho0.^2;

% check if quadratic, not, or impossible
if( rho02< 1)
  quadratic=1;
else
  if(rho02==1)
    quadratic=0;
  else
    error('rho02>1');
  end
end


%% calculating the gaussian coefficients

b = zeros(freqno,1);
botlambda=-1000000;
toplambda=-0.000000001;
b=solvequadratic(var_s,var_u, var_n, rho02, toplambda, quadratic);
toppower = b'*var_s;
b=solvequadratic(var_s,var_u, var_n, rho02, botlambda, quadratic);
botpower = b'*var_s;

if( desiredpower < botpower || desiredpower > toppower)
  error('botlambda and toplambda specify insufficient range in %s\n',mfilename);
end

power_ratio=2;
n=0;
while( abs(power_ratio-1)>0.0001 || n>=100)
  midlambda=(botlambda+toplambda)/2;
  b=solvequadratic(var_s,var_u, var_n, rho02, midlambda, quadratic);
  midpower = b'*var_s;
  if(midpower < desiredpower)
    botlambda = midlambda;
  else
    toplambda = midlambda;
  end
  power_ratio=abs(midpower/desiredpower);
  n=n+1;
end
 

% scale
 
for(n=1:freqno)
  MVDR_out_post(n,:) = sqrt(b(n))*(MVDR_out(n,:));
end
 

end
